<template>
  <div class="w-full">
    <FloatLabel class="w-full">
      <Password
        class="form-input form-input-password w-full"
        v-model="value"
        v-bind="attrs"
        toggleMask
        :type="isMask ? 'password' : 'text'"
        :class="{ 'p-invalid': attrs.errorMessage }"
        :rules="attrs.rules"
        :name="attrs.name"
        promptLabel="Введите пароль"
        weakLabel="Слабый пароль"
        mediumLabel="Нормальный пароль"
        strongLabel="Сложный пароль"
        :mediumRegex="'^(?=.*?[A-ZА-Я])(?=.*?[a-zа-я])(?=.*?[0-9])(?=.*?[#?!@$ %^&*-]).{8,32}$'"
        :strongRegex="'^(?=(?:.*[A-ZА-Я]){3})(?=.*[a-zа-я])(?=.*[0-9])(?=.*[#?!@$ %^&*-]).{8,32}$'"
        @input="onInput"
      >
        <template #header>
          <h6>Введите пароль</h6>
        </template>
        <!-- <template #content> </template> -->
        <template #footer>
          <Divider />
          <p class="mt-2">Требования:</p>
          <ul class="pl-2 ml-2 mt-0" style="line-height: 1.5">
            <li
              v-if="minCharacters"
              class="form-input-password__suggetions"
              :class="{
                'form-input-password__suggetions--del': suggetions.minCharacters
              }"
            >
              Минимум {{ minCharacters }}
              {{
                $declension(minCharacters, ['символ', 'символа', 'символов'])
              }}
            </li>
            <li
              v-if="minUppercase"
              class="form-input-password__suggetions"
              :class="{
                'form-input-password__suggetions--del': suggetions.minUppercase
              }"
            >
              Минимуму одна заглавная буква
            </li>
            <li
              v-if="minLowercase"
              class="form-input-password__suggetions"
              :class="{
                'form-input-password__suggetions--del': suggetions.minLowercase
              }"
            >
              Минимуму одна строчная буква
            </li>
            <li
              v-if="minNumber"
              class="form-input-password__suggetions"
              :class="{
                'form-input-password__suggetions--del': suggetions.minNumber
              }"
            >
              Минимум одна цифра
            </li>
            <li
              v-if="minSymbol"
              class="form-input-password__suggetions"
              :class="{
                'form-input-password__suggetions--del': suggetions.minSymbol
              }"
            >
              Минимум один символ
            </li>
          </ul>
        </template>
      </Password>
      <label v-if="attrs.label" :for="attrs.id">{{ attrs.label }}</label>
    </FloatLabel>
    <small id="text-error" class="p-error">{{
      attrs.errorMessage || null
    }}</small>
  </div>
</template>

<script setup lang="ts">
import Password from 'primevue/password'

const { $validationRules, $declension } = useNuxtApp()

const attrs = useAttrs() as any
const emit = defineEmits(['update:modelValue'])

const suggetions = ref({
  minCharacters: false,
  minUppercase: false,
  minLowercase: false,
  minNumber: false,
  minSymbol: false
})

const onInput = (event: any) => {
  $validationRules.password(
    event.target?.value,
    (successRules: any) => (suggetions.value = successRules)
  )
}

const props = defineProps({
  modelValue: {
    type: String,
    required: true
  },
  minCharacters: {
    type: Number,
    required: true
  },
  minUppercase: {
    type: Boolean,
    required: false
  },
  minLowercase: {
    type: Boolean,
    required: false
  },
  minNumber: {
    type: Boolean,
    required: false
  },
  minSymbol: {
    type: Boolean,
    required: false
  }
})

const value = computed({
  get() {
    return props.modelValue
  },
  set(value) {
    emit('update:modelValue', value)
  }
})

const isMask = ref(true)
</script>

<style lang="scss" scoped>
.form-input-password {
  &__suggetions {
    &--del {
      text-decoration: line-through;
    }
  }

  ::v-deep(.p-password-input) {
    width: 100%;
  }

  ::v-deep(svg) {
    cursor: pointer;
  }
}
</style>
